<?php

/**
 *  Cart Reminder
 *  Created by Jonet Greene for Above Media http://www.abovemedia.com
 *  Version 1.0 
 * 
 *  License: http://www.zen-cart.com/license/2_0.txt GNU Public License V2.0 
 * 
 *  Cron job file
 *  
**/

/* Change the path if you are putting the cron file anywhere other than the top level directory of your shop. */

$directory = 'includes/';

/* Don't change anything below*/

require_once($directory.'configure.php');

$db = mysql_connect(DB_SERVER, DB_SERVER_USERNAME, DB_SERVER_PASSWORD);
if (!$db) {
    die('Could not connect: ' . mysql_error());
}
$db_selected = mysql_select_db(DB_DATABASE, $db);
if (!$db_selected) {
    die ('Can\'t use '.DB_DATABASE.' : ' . mysql_error());
}

/*Check to see if module is being used.*/

$sql ="SELECT configuration_value FROM `".DB_PREFIX."configuration` WHERE configuration_key = 'CART_REMINDER'";
$result = mysql_query($sql);
$row = mysql_fetch_assoc($result);
if($row['configuration_value'] == false){
/*should we clear table? */
exit;

}




/* Step 1: Remove all items in cart_reminder table that don't have an associated cart (where the users aren't logged in) */

$sql = "DELETE cart_reminder.*
	FROM ".DB_PREFIX."cart_reminder
	LEFT JOIN ".DB_PREFIX."whos_online ON ".DB_PREFIX."cart_reminder.customer_id = whos_online.customer_id
	LEFT JOIN ".DB_PREFIX."customers_basket ON ".DB_PREFIX."cart_reminder.customer_id = ".DB_PREFIX."customers_basket.customers_id
	WHERE ".DB_PREFIX."customers_basket.customers_id IS NULL
	AND ".DB_PREFIX."whos_online.customer_id IS NULL";



$result = mysql_query($sql);

/* Step 2: Get all settings */

$sql ="SELECT template_dir  FROM ".DB_PREFIX ."template_select";
$result = mysql_query($sql);
$row = mysql_fetch_assoc($result);
$settings['template_dir'] = $row['template_dir'];

$sql ="SELECT configuration_value FROM ".DB_PREFIX ."configuration WHERE configuration_key = 'EMAIL_USE_HTML'";
$result = mysql_query($sql);
$row = mysql_fetch_assoc($result);
$settings['html_email'] = $row['configuration_value'];

$sql ="SELECT configuration_value FROM ".DB_PREFIX ."configuration  WHERE configuration_key = 'CART_REMINDER_SUBJECT'";
$result = mysql_query($sql);
$row = mysql_fetch_assoc($result);
$settings['subject'] = $row['configuration_value'];

$sql ="SELECT configuration_value FROM ".DB_PREFIX ."configuration WHERE configuration_key = 'CART_REMINDER_HOURS'";
$result = mysql_query($sql);
$row = mysql_fetch_assoc($result);
$settings['mail_time'] = $row['configuration_value'];

$sql ="SELECT configuration_value FROM ".DB_PREFIX ."configuration WHERE configuration_key = 'STORE_NAME'";
$result = mysql_query($sql);
$row = mysql_fetch_assoc($result);
$content['STORE_NAME'] = $row['configuration_value'];

$sql ="SELECT configuration_value FROM ".DB_PREFIX ."configuration WHERE configuration_key = 'EMAIL_FROM'";
$result = mysql_query($sql);
$row = mysql_fetch_assoc($result);
$settings['email_from'] = $row['configuration_value'];

$sql ="SELECT configuration_value FROM ".DB_PREFIX ."configuration WHERE configuration_key = 'STORE_TELEPHONE_CUSTSERVICE'";
$result = mysql_query($sql);
$row = mysql_fetch_assoc($result);
$content['STORE_TELEPHONE'] = $row['configuration_value'];

$content['WEBSITE_ADDRESS'] = HTTP_SERVER.DIR_WS_CATALOG;


/* 	Step 3: Get all the mail info 	*/
$mail_time = date('Y-m-d H:i:s', strtotime('-'.$settings['mail_time']. ' hour'));
$sql = "SELECT ".DB_PREFIX."cart_reminder.customer_id, ".DB_PREFIX."customers.customers_firstname, ".DB_PREFIX."customers.customers_lastname, ".DB_PREFIX."customers.customers_email_address, ".DB_PREFIX."customers_basket.customers_basket_quantity, ".DB_PREFIX."customers.customers_email_format, ".DB_PREFIX."products_description.products_id, ".DB_PREFIX."products_description.products_name
	FROM ".DB_PREFIX."customers, ".DB_PREFIX."products_description, ".DB_PREFIX."cart_reminder
	LEFT JOIN ".DB_PREFIX."whos_online ON ".DB_PREFIX."cart_reminder.customer_id = ".DB_PREFIX."whos_online.customer_id, ".DB_PREFIX."customers_basket
	WHERE ".DB_PREFIX."whos_online.customer_id IS NULL
	AND ".DB_PREFIX."cart_reminder.customer_id = ".DB_PREFIX."customers_basket.customers_id
	AND ".DB_PREFIX."cart_reminder.customer_id = ".DB_PREFIX."customers.customers_id
	AND ".DB_PREFIX."products_description.products_id = ".DB_PREFIX."customers_basket.products_id 
	AND ".DB_PREFIX."cart_reminder.log_in_time <= '$mail_time' 
	ORDER BY ".DB_PREFIX."cart_reminder.customer_id";


//echo date('Y-m-d H:i:s').'<br>';
//echo $mail_time.'<br>';
//echo $sql .'<br>';



$result = mysql_query($sql);
while($row = mysql_fetch_assoc($result)){
	$delete_list[] = $row['customer_id'];
	if(empty($mail_info[$row['customer_id']])){	
		$mail_info[$row['customer_id']] = array();
		$mail_info[$row['customer_id']]['customers_firstname'] = $row['customers_firstname'];
		$mail_info[$row['customer_id']]['customers_lastname'] = $row['customers_lastname'];
		$mail_info[$row['customer_id']]['customers_email_address'] = $row['customers_email_address'];		
		$mail_info[$row['customer_id']]['customers_email_format'] = $row['customers_email_format'];
	}

	$mail_info[$row['customer_id']]['shopping_cart'][] = array('id' =>$row['products_id'], 'name' => $row['products_name'], 'quantity' => $row['customers_basket_quantity']);

}


if(empty($mail_info)){
//echo 'the $mail_info array is empty';
exit;

}



	foreach($mail_info as $key => $value){
		$random_hash = md5(date('r', time()));
		$headers  = "MIME-Version: 1.0\n";	
	
		if($settings['html_email'] == true && $mail_info[$key]['customers_email_format'] == 'HTML'){

			$headers.= "Content-type: multipart/alternative; boundary=\"PHP-mixed-".$random_hash."\"\r\n";
			$mail_body = "--PHP-mixed-".$random_hash."\nContent-Type: text/plain; charset=\"iso-8859-1\"\nContent-Transfer-Encoding: 7bit\n\n";

			$html_template = file_get_contents(DIR_FS_CATALOG.'email/email_template_cart_reminder.html');




		}
		else{
			$headers.= "Content-Type: text/plain\n";
			$mail_body = "";
		}		

		$headers.=  "From: ".$settings['email_from']."\n";	
		$subject = $settings['subject'];
		if (file_exists(DIR_FS_CATALOG.'includes/languages/english/html_includes/'.$settings['template_dir'].'/define_cart_reminder.php')) {
			$mail_body .= file_get_contents(DIR_FS_CATALOG.'includes/languages/english/html_includes/'.$settings['template_dir'].'/define_cart_reminder.php');
			$mail_body .= "\n\n";
		} else {
			$mail_body .= file_get_contents(DIR_FS_CATALOG.'includes/languages/english/html_includes/define_cart_reminder.php');
			$mail_body .= "\n\n";

		}	
	
		if($settings['html_email'] == true && $mail_info[$key]['customers_email_format'] == 'HTML'){
			$mail_body .= "--PHP-mixed-".$random_hash."\nContent-Type: text/html; charset=\"iso-8859-1\"\nContent-Transfer-Encoding: 7bit\n\n";
			$mail_body .= $html_template;
			$mail_body ."--PHP-mixed-".$random_hash."--";	
		
		}
		$content['CUSTOMERS_FIRSTNAME'] = $mail_info[$key]['customers_firstname'];
		$content['CUSTOMERS_LASTNAME'] = $mail_info[$key]['customers_lastname'];
		
		
		/* Handle Shopping Cart */
		$content['SHOPPING_CART'] = '';	
		$content['HTML_SHOPPING_CART'] = '';
			$cart_items_count = count($mail_info[$key]['shopping_cart']);
			for($i=0;$i<$cart_items_count;++$i){
				$content['SHOPPING_CART'].= $mail_info[$key]['shopping_cart'][$i]['name']."\n" ;
				$content['SHOPPING_CART'].= "Quantity: ".$mail_info[$key]['shopping_cart'][$i]['quantity']."\n" ;
				$content['SHOPPING_CART'].= HTTP_SERVER.DIR_WS_CATALOG.'index.php?main_page=product_info&products_id='.$mail_info[$key]['shopping_cart'][$i]['id']." \n\n" ;
			
				if($settings['html_email'] == true && $mail_info[$key]['customers_email_format'] == 'HTML'){
					$content['HTML_SHOPPING_CART'].= '<a href="'.HTTP_SERVER.DIR_WS_CATALOG.'index.php?main_page=product_info&products_id='.$mail_info[$key]['shopping_cart'][$i]['id'].'">'.$mail_info[$key]['shopping_cart'][$i]['name'].'</a><br>';
					$content['HTML_SHOPPING_CART'].= "Quantity: ".$mail_info[$key]['shopping_cart'][$i]['quantity'].'<br><br>';


				}			
			
			
			}
			
		foreach($content as $key2=>$value2){
			$regex = '{'.strtoupper($key2).'}';
			$mail_body = preg_replace("/$regex/", $value2, $mail_body);
		}
 		
		$mail_to = mail($mail_info[$key]['customers_email_address'], $subject, $mail_body, $headers);	
	
	}
	
	$sql = "DELETE FROM  ".DB_PREFIX ."cart_reminder WHERE customer_id IN (".implode(',', $delete_list).")";
	$result = mysql_query($sql);	
	
